Attribute VB_Name = "modScreen"
Option Explicit

'Call LoadMonitors() to initialize the monitor list
Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Public Type PictDesc_BMP
    Size As Long
    Type As Long
    hBmp As Long
    hpal As Long
    Reserved As Long
End Type


Public IID_IPicture(15) As Byte
Public IPictureInitialized As Boolean
Public IPictureIID As GUID

Public Type POINTAPI
    X As Long
    Y As Long
End Type


Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Const vbCapBlt = &H40000000    'missing bitblt option

Public Const LOGPIXELSX = 88
Public Const LOGPIXELSY = 90


Private Const SM_CXVIRTUALSCREEN = 78
Private Const SM_CYVIRTUALSCREEN = 79
Private Const SM_XVIRTUALSCREEN As Long = 76
Private Const SM_YVIRTUALSCREEN As Long = 77

Private Const SM_CMONITORS = 80
Private Const SM_SAMEDISPLAYFORMAT = 81

Public Const DISPLAY_DEVICE_ATTACHED_TO_DESKTOP As Long = &H1
Public Const DISPLAY_DEVICE_MIRRORING_DRIVER As Long = &H8
Public Const DISPLAY_DEVICE_MODESPRUNED As Long = &H8000000
Public Const DISPLAY_DEVICE_MULTI_DRIVER As Long = &H2
Public Const DISPLAY_DEVICE_PRIMARY_DEVICE As Long = &H4
Public Const DISPLAY_DEVICE_VGA_COMPATIBLE As Long = &H10
Public Const DISPLAY_DEVICE_REMOVABLE As Integer = &H20
Public Const DISPLAY_DEVICE_ACTIVE = &H1

Private Const MONITORINFOF_PRIMARY As Integer = &H1

Type DISPLAY_DEVICE
    cb As Long
    DeviceName As String * 32
    DeviceString As String * 128
    StateFlags As Long
    DeviceID As String * 128
    DeviceKey As String * 128
End Type


Public Type MONITORINFO
    cbSize As Long
    rcMonitor As RECT
    rcWork As RECT
    dwFlags As Long
    szDevice As String * 32
End Type

'general UDT to hold information about a monitor
'the Monitors() list is an array of this type
Public Type MonitorItem
    Left As Long
    Top As Long
    Height As Long
    Width As Long

    Primary As Boolean     'true if this is the primary monitor (same as isDefault)
    Removable As Boolean   'true if this display is removeable
    VgaCompat As Boolean   'true if this display is VGA compatible
    Active As Boolean      'true if this monitor is active
    hMon As Long           'handle to the monitor
    Portrait As Boolean   'true if monitor is in portrait mode
    Name As String         'internal windows name of the monitor
    Model As String        'model of the monitor
    Description As String  'description of the monitor
    isDefault As Boolean   'true if this monitor is the default (same as Primary)
    MonitorIndex As Long   'the index of this monitor in the Monitors() list

    'note: the difference between .Primary and .isDefault is one is
    'info returned by EnumDisplayMonitors() and the other EnumDisplayDevices()
    'in theory both should be the same value for every monitor

    mi As MONITORINFO      'the structure returned by EnumDisplayMonitors()
    dd As DISPLAY_DEVICE   'the structure returned by EnumDisplayDevices()
    PixelsPerInchX As Long
    PixelsPerInchY As Long
    TwipsY As Long
    TwipsX As Long
End Type

Public Declare Function EnumDisplayMonitors Lib "user32.dll" (ByVal hDC As Long, ByVal lprcClip As Long, ByVal lpfnEnum As Long, ByVal dwData As Long) As Long

Public Declare Function EnumDisplayDevices Lib "user32.dll" Alias "EnumDisplayDevicesA" (ByVal lpDevice As String, ByVal iDevNum As Long, ByRef lpDisplayDevice As DISPLAY_DEVICE, ByVal dwFlags As Long) As Long

Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long

Private Declare Function GetMonitorInfo Lib "user32.dll" Alias "GetMonitorInfoA" (ByVal hMonitor As Long, lpmi As MONITORINFO) As Long

Public Declare Sub MonitorFromPoint Lib "user32.dll" (ByVal pt As POINTAPI, ByVal dwFlags As Long)
Public Declare Sub MonitorFromRect Lib "user32.dll" (ByRef lprc As RECT, ByVal dwFlags As Long)
Public Declare Sub MonitorFromWindow Lib "user32.dll" (ByVal hWnd As Long, ByVal dwFlags As Long)

Public Declare Function CreateDC Lib "gdi32.dll" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, ByVal lpInitData As Long) As Long    ' ByRef lpInitData As DEVMODE) As Long

Public Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hDC As Long, ByVal nIndex As Long) As Long

Public Declare Function DeleteDC Lib "gdi32.dll" (ByVal hDC As Long) As Long

Public Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hDC As Long) As Long

Public Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long

Public Declare Function BitBlt Lib "gdi32.dll" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Public Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hObject As Long) As Long

Public Declare Function OleCreatePictureIndirect_BMP Lib "oleaut32.dll" Alias "OleCreatePictureIndirect" (ByRef lpPictDesc As PictDesc_BMP, riid As GUID, ByVal fOwn As Long, ByRef lplpvObj As Any) As Long

Public Declare Function CLSIDFromString Lib "ole32" (ByVal lpsz As Any, pclsid As Any) As Long


'if you have a way for the user to choose which monitor to
'display your app on, this should reflect that index into
'the sorted MonitorOrder() list, you could make some changes
'and also index directly into the Monitors() list
Public SelectedMonitor As Long

'unsorted list of monitors as returned by EnumDisplayMonitors()
Public Monitors() As MonitorItem

'count of monitors in the Monitors() list
Public MonitorCount As Long

'true if all monitors have an equal display format
Public MonitorsEqual As Boolean

'virtual screen height and width of all monitors combined
Public vScreenWidth As Long
Public vScreenHeight As Long

'an index into the monitors() list, of the default monitor.
Public DefaultIndex As Long

'the physical sort order of the monitors from left to right as the user has specified.
'note: if the user has specified an arrangement contrary to the physical arrangement
'      then they are weird and deserve the unpredictable result.
'use MonitorCount - 1 as upperbound. Use this to index into the Monitors list.
'ex: Monitors(MonitorOrder(0)).Top - gets the top of the left most monitor
'ex: Monitors(MonitorOrder(MonitorCount - 1)).Top - gets the top of the right most monitor
Public MonitorOrder() As Long




Public Property Get VirtualScreenWidth() As Long
    VirtualScreenWidth = GetSystemMetrics(SM_CXVIRTUALSCREEN)
End Property
Public Property Get VirtualScreenHeight() As Long
    VirtualScreenHeight = GetSystemMetrics(SM_CYVIRTUALSCREEN)
End Property

Public Property Get VirtualScreenLeft() As Long
    VirtualScreenLeft = GetSystemMetrics(SM_XVIRTUALSCREEN)
End Property
Public Property Get VirtualScreenTop() As Long
    VirtualScreenTop = GetSystemMetrics(SM_YVIRTUALSCREEN)
End Property


'have read that this is unreliable
Public Property Get DisplayMonitorCount() As Long
    DisplayMonitorCount = GetSystemMetrics(SM_CMONITORS)
End Property

'this will tell you if all monitors have the same display format
Public Property Get AllMonitorsSame() As Long
    AllMonitorsSame = GetSystemMetrics(SM_SAMEDISPLAYFORMAT)
End Property

'this sorts monitors according to how the user has them sorted
'from left to right, which usually mirrors
'how the user has them physically placed (but can be different)
'the array MonitorSort() will contain the sorted monitor index's
Public Sub SortMonitors()

    Dim X As Long, B As Boolean, Temp As Long

    If MonitorCount Then
        If MonitorCount = 1 Then
            ReDim MonitorOrder(0) As Long
            MonitorOrder(0) = 0
        Else

            'set default order
            ReDim MonitorOrder(MonitorCount - 1) As Long
            For X = 0 To MonitorCount - 1
                MonitorOrder(X) = X
            Next X
            X = 0

            'bubble sort monitors
            Do
                B = False

                Do While X < MonitorCount
                    If X < MonitorCount - 1 Then
                        With Monitors(MonitorOrder(X)).mi
                            If .rcWork.Left > Monitors(MonitorOrder(X + 1)).mi.rcWork.Left Then
                                'swap
                                Temp = MonitorOrder(X)
                                MonitorOrder(X) = MonitorOrder(X + 1)
                                MonitorOrder(X + 1) = Temp
                                'we did a thing
                                B = True
                                Exit Do
                            End If
                        End With
                    End If
                    X = X + 1
                Loop

            Loop While B
        End If
    End If


End Sub

'puts a rect into a string for debug purposes
Function RcToList(ByVal rName As String, rc As RECT) As String

    With rc
        RcToList = rName & " (L: " & .Left & " T: " & .Top & " B: " & .Bottom & " R: " & .Right & ")"
    End With

End Function

'searches the monitor list for a monitor with the given device name
Function GetMonitorByDevName(ByVal DevName As String) As Long

    Dim X As Long, S As String, I As Long

    If MonitorCount Then

        For X = 0 To MonitorCount - 1
            With Monitors(X).mi

                'check szDevice for nulls
                S = Normalize(.szDevice)

                'check devname for nulls
                DevName = Normalize(DevName)

                If StrComp(S, DevName, vbTextCompare) = 0 Then
                    GetMonitorByDevName = X
                    Exit Function
                End If

            End With
        Next X

    End If

    GetMonitorByDevName = -1

End Function


'aka strip nulls
Function Normalize(ByVal szName As String) As String

    Dim I As Long

    If Len(szName) = 0 Then Exit Function

    I = InStr(szName, vbNullChar)
    If I > 1 Then
        Normalize = Left$(szName, I - 1)
    Else

        If Len(szName) Then
            If szName <> String$(Len(szName), vbNullChar) Then
                Normalize = szName
            End If
        End If

    End If


End Function

'parses the model name of the monitor from its device ID string
' Monitor\<model>\id-876-87 etc
Function ParseNameFromDevId(ByVal DevId As String) As String

    Dim Arr() As String

    DevId = Normalize(DevId)
    If InStr(DevId, "\") Then
        Arr = Split(DevId, "\")
        ParseNameFromDevId = Arr(1)
    End If

End Function


'these 4 functions get left,top,width,height of the user selected monitor
'if the optional index of the monitor is omitted the default monitor is used
Function MonitorLeft(Optional ByVal mIndex As Long = -1) As Long
    If mIndex = -1 Then mIndex = DefaultIndex
    MonitorLeft = Monitors(mIndex).Left
End Function

Function MonitorTop(Optional ByVal mIndex As Long = -1) As Long
    If mIndex = -1 Then mIndex = DefaultIndex
    MonitorTop = Monitors(mIndex).Top
End Function

Function MonitorWidth(Optional ByVal mIndex As Long = -1) As Long
    If mIndex = -1 Then mIndex = DefaultIndex
    MonitorWidth = Monitors(mIndex).Width
End Function

Function MonitorHeight(Optional ByVal mIndex As Long = -1) As Long
    If mIndex = -1 Then mIndex = DefaultIndex
    MonitorHeight = Monitors(mIndex).Height
End Function


'EnumDisplayMonitors() callback function
Public Function EnumMonitorCallback(ByVal hMonitor As Long, ByVal hdcMonitor As Long, ByVal lprcMonitor As Long, ByVal dwData As Long) As Long
    Dim mi As MONITORINFO
    Dim ret As Long
    Dim TwipsY As Long
    Dim TwipsX As Long
    Dim hDC As Long
    Dim PixelsPerInchX As Long
    Dim PixelsPerInchY As Long

    With mi
        .cbSize = Len(mi)
        ret = GetMonitorInfo(hMonitor, mi)
        If ret Then

            ReDim Preserve Monitors(MonitorCount) As MonitorItem
            Let Monitors(MonitorCount).mi = mi

            With Monitors(MonitorCount)
                If .mi.dwFlags And MONITORINFOF_PRIMARY Then
                    'note: in the enumdisplaydevices loop in the LoadMonitors function
                    ' .isDefault is the same as .Primary (in theory)
                    'and SelectedMonitor (if not initialized by user) is the same as DefaultIndex (again, in theory)
                    .Primary = True
                    DefaultIndex = MonitorCount
                End If
                'remove trailing nulls in the name string
                .Name = Normalize(.mi.szDevice)

                'msdn docx state that this value will be the same for all displays
                '    TwipsX = Screen.TwipsPerPixelX
                '    TwipsY = Screen.TwipsPerPixelY

                'Twip is 1/20 of a point, which in turn is 1/72 of an inch. Thus, twip is 1/1440 of an inch.
                'To convert from twips to pixels and vice versa, you have to take into account logical inch size
                'of the output device (display or printer).
                '
                'PixelsX = TwipsX * GetDeviceCaps(hDC, LOGPIXELSX) / 1440;
                'PixelsY = TwipsY * GetDeviceCaps(hDC, LOGPIXELSY) / 1440;
                '
                'TwipsX = PixelsX * 1440 / GetDeviceCaps(hDC, LOGPIXELSX);
                'TwipsY = PixelsY * 1440 / GetDeviceCaps(hDC, LOGPIXELSY);
                '
                'For a typical display, a logical inch is 96 pixels, which yields 15 twips per pixel.
                '-------------------------------------------------------------------------------------
                '2 different ways to get same thing - aka monitor specific display context(DC)
                'hDC = CreateDC("DISPLAY", .Name, 0, 0)
                hDC = CreateDC(.Name, 0, 0, 0)

                'hDC = CreateDC("DISPLAY", vbNullString, 0, 0) 'entire virtual screen

                .PixelsPerInchX = GetDeviceCaps(hDC, LOGPIXELSX)
                .PixelsPerInchY = GetDeviceCaps(hDC, LOGPIXELSY)
                DeleteDC hDC

                .TwipsX = CLng(1440& / .PixelsPerInchX)
                .TwipsY = CLng(1440& / .PixelsPerInchY)

                .Left = .mi.rcMonitor.Left * .TwipsX
                .Top = .mi.rcMonitor.Top * .TwipsY
                .Width = (.mi.rcMonitor.Right - .mi.rcMonitor.Left) * .TwipsX
                .Height = (.mi.rcMonitor.Bottom - .mi.rcMonitor.Top) * .TwipsY
                .hMon = hMonitor
                .MonitorIndex = MonitorCount
                .Portrait = (.Height > .Width)
            End With

            MonitorCount = MonitorCount + 1
        Else
            'Debug.Print Err.Number; Err.Description; Err.LastDllError
        End If
    End With

    EnumMonitorCallback = 1

End Function

Function Min(ByVal Val1 As Long, ByVal Val2 As Long) As Long
    If Val1 < Val2 Then
        Min = Val1
    Else
        Min = Val2
    End If

End Function




'call this once at program start to load all monitors
Sub LoadMonitors()

    Dim lRet As Long, X As Long, I As Long
    Dim dd As DISPLAY_DEVICE, clr As DISPLAY_DEVICE

    vScreenWidth = VirtualScreenWidth
    vScreenHeight = VirtualScreenHeight
    MonitorsEqual = AllMonitorsSame

    On Error Resume Next

    SelectedMonitor = CLng(GetSetting("Monitors", "Monitor", "Selected", "-1"))

    lRet = EnumDisplayMonitors(0&, ByVal 0&, AddressOf EnumMonitorCallback, 0&)

    'Debug.Print Err.Number; Err.Description; Err.LastDllError

    dd.cb = Len(dd)
    clr.cb = Len(clr)

    While EnumDisplayDevices(vbNullString, X, dd, 0)
        If dd.StateFlags And DISPLAY_DEVICE_ATTACHED_TO_DESKTOP Then
            'we want to preserve the flags, because the second call changes them
            clr.StateFlags = dd.StateFlags
            'get extra info from (device name)
            lRet = EnumDisplayDevices(dd.DeviceName, 0, dd, 0)
            dd.StateFlags = clr.StateFlags
            clr.StateFlags = 0
            'Debug.Print dd.DeviceID; dd.DeviceKey; dd.DeviceName; dd.DeviceString; dd.StateFlags

            'find this display in the monitor list
            I = GetMonitorByDevName(dd.DeviceName)
            If I <> -1 Then
                Monitors(I).dd = dd
                'get monitor model
                Monitors(I).Model = ParseNameFromDevId(dd.DeviceID)
                Monitors(I).Name = Normalize(dd.DeviceName)
                Monitors(I).Description = Normalize(dd.DeviceString)

                With Monitors(I)
                    If dd.StateFlags And DISPLAY_DEVICE_PRIMARY_DEVICE Then
                        .isDefault = True
                        If SelectedMonitor = -1 Then
                            SelectedMonitor = I
                        End If
                    End If

                    If dd.StateFlags And DISPLAY_DEVICE_ACTIVE Then
                        .Active = True
                    End If
                    If dd.StateFlags And DISPLAY_DEVICE_REMOVABLE Then
                        .Removable = True
                    End If
                    If dd.StateFlags And DISPLAY_DEVICE_VGA_COMPATIBLE Then
                        .VgaCompat = True
                    End If
                End With

            End If
        End If
        Let dd = clr
        X = X + 1
    Wend

    SortMonitors



End Sub


'take a screenshot of a entire monitor, returns a picture object
Function ScreenShot(Optional ByVal lMonitorIndex As Long = -1, Optional bIncludeTaskbar As Boolean = False) As IPicture

    Dim sHdc As Long
    Dim pHdc As Long
    Dim hBmp As Long
    Dim OBmp As Long
    Dim R As RECT
    Dim ret As Long

    If lMonitorIndex = -1 Then lMonitorIndex = DefaultIndex

    With Monitors(lMonitorIndex)
        sHdc = CreateDC("DISPLAY", .Name, 0, ByVal 0&)
        If bIncludeTaskbar Then
            Let R = .mi.rcMonitor
        Else
            Let R = .mi.rcWork
        End If
    End With

    pHdc = CreateCompatibleDC(sHdc)
    hBmp = CreateCompatibleBitmap(sHdc, R.Right - R.Left, R.Bottom - R.Top)
    OBmp = SelectObject(pHdc, hBmp)

    ret = BitBlt(pHdc, 0, 0, R.Right - R.Left, R.Bottom - R.Top, sHdc, 0, 0, vbSrcCopy Or vbCapBlt)

    hBmp = SelectObject(pHdc, OBmp)

    DeleteDC sHdc
    DeleteDC pHdc

    Set ScreenShot = PicFromBmp(hBmp)

End Function


'take a screenshot of an area on a monitor, returns a picture object
Function ScreenShotArea(Area As RECT, Optional ByVal lMonitorIndex As Long = -1) As IPicture

    Dim sHdc As Long
    Dim pHdc As Long
    Dim hBmp As Long
    Dim OBmp As Long
    Dim ret As Long
    Dim R As RECT


    If lMonitorIndex = -1 Then lMonitorIndex = DefaultIndex
    With Monitors(lMonitorIndex)
        R = .mi.rcMonitor

        sHdc = CreateDC("DISPLAY", Monitors(lMonitorIndex).Name, 0, ByVal 0&)

        pHdc = CreateCompatibleDC(sHdc)
        hBmp = CreateCompatibleBitmap(sHdc, Area.Right - Area.Left, Area.Bottom - Area.Top)
        OBmp = SelectObject(pHdc, hBmp)

        ret = BitBlt(pHdc, 0, 0, Area.Right - Area.Left, Area.Bottom - Area.Top, sHdc, Area.Left, Area.Top, vbSrcCopy)

    End With

    hBmp = SelectObject(pHdc, OBmp)

    DeleteDC sHdc
    DeleteDC pHdc

    Set ScreenShotArea = PicFromBmp(hBmp)

End Function



'same as above but uses default options (no palette or pictype)
Public Function PicFromBmp(ByVal hBmp As Long) As IPicture

    Dim ip As IPicture, pd As PictDesc_BMP
    Dim ret As Long

    If Not IPictureInitialized Then
        InitIPicture
    End If

    With pd
        .Size = Len(pd)
        .Type = vbPicTypeBitmap
        .hBmp = hBmp
    End With

    ret = OleCreatePictureIndirect_BMP(pd, IPictureIID, 1, ip)

    Set PicFromBmp = ip

End Function


'caches the ipic guid so that subsequent picfromstream calls are faster
Function InitIPicture() As Boolean

    IPictureInitialized = (CLSIDFromString(StrPtr("{7BF80980-BF32-101A-8BBB-00AA00300CAB}"), IID_IPicture(0)) = 0)

    ' Fill in IPicture GUID {7BF80980-BF32-101A-8BBB-00AA00300CAB}
    With IPictureIID
        .Data1 = &H7BF80981
        .Data2 = &HBF32
        .Data3 = &H101A
        .Data4(0) = &H8B
        .Data4(1) = &HBB
        .Data4(3) = &HAA
        .Data4(5) = &H30
        .Data4(6) = &HC
        .Data4(7) = &HAB
    End With
    InitIPicture = IPictureInitialized

End Function












